
/******************************************************************************
* MODULE     : string_append.cpp
* DESCRIPTION: Append strings
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "string.hpp"
namespace mml {

void
string_rep::extend (nat d) {
  if (n+d > l) {
    l= max (l << 1, n+d);
    char* b= new char[l];
    for (nat i=0; i<n; i++)
      b[i]= a[i];
    delete[] a;
    a= b;
  }
  n += d;
}

string&
operator << (string& s, char x) {
  s->extend (1);
  s [N(s)-1]= x;
  return s;
}

string&
operator << (string& s1, string s2) {
  register nat i, k1= N(s1), k2=N(s2);
  s1->extend (k2);
  for (i=0; i<k2; i++) s1[i+k1]= s2[i];
  return s1;
}

string
operator * (string s1, string s2) {
  register nat i, n1=N(s1), n2=N(s2);
  string r(n1+n2);
  for (i=0; i<n1; i++) r[i]=s1[i];
  for (i=0; i<n2; i++) r[i+n1]=s2[i];
  return r;
}

} // namespace mml
