
/******************************************************************************
* MODULE     : string.cpp
* DESCRIPTION: Equality testing for strings
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "string.hpp"
namespace mml {

bool
string::operator == (char* s) {
  register nat i, n= rep->n;
  register char* S= rep->a;
  for (i=0; i<n; i++) {
    if (s[i]!=S[i]) return false;
    if (s[i]=='\0') return false;
  }
  return (s[i]=='\0');
}

bool
string::operator == (string s) {
  register nat i;
  if (rep->n != s.rep->n) return false;
  for (i=0; i<rep->n; i++)
    if (rep->a[i] != s.rep->a[i]) return false;
  return true;
}

} // namespace mml
