
/******************************************************************************
* MODULE     : vector_test.cc
* DESCRIPTION: Test vectors
* COPYRIGHT  : (C) 2004  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "vector.hpp"
using namespace mml;

int
main () {
  vector<int> v(1,10);
  cout << "v\t= " << v << "\n";
  vector<int,vector_fixed<10> > x(3);
  vector<int,vector_fixed<10> > y(7);
  cout << "x\t= " << x << "\n";
  cout << "y\t= " << y << "\n";
  cout << "-x\t= " << -x << "\n";
  cout << "x+x\t= " << x+x << "\n";
  cout << "x-x\t= " << x-x << "\n";
  cout << "x*x\t= " << x*x << "\n";
  cout << "2*x\t= " << 2*x << "\n";
  cout << "x*2\t= " << x*2 << "\n";
  cout << "x/3\t= " << x/3 << "\n";
  cout << "x+=y\t= " << (x+=y) << "\n";
  cout << "x-=y\t= " << (x-=y) << "\n";
  cout << "x*=y\t= " << (x*=y) << "\n";
  cout << "x/=y\t= " << (x/=y) << "\n";
  cout << "x*=11\t= " << (x*=11) << "\n";
  cout << "x/=11\t= " << (x/=11) << "\n";
  cout << "x=y\t= " << (x==y) << "\n";
  cout << "x!=y\t= " << (x!=y) << "\n";
  cout << "x<y\t= " << (x<y) << "\n";
  cout << "x<=y\t= " << (x<=y) << "\n";
  cout << "x>y\t= " << (x>y) << "\n";
  cout << "x>=y\t= " << (x>=y) << "\n";
  return 0;
}
